##PROJECT_GLOBAL_BEGIN
[Programs]
Count=1

[Misc Info]
Author=
Company=
Version=1.0
EditTime=870
CyProVersion=3.0.7

[Protection]
Level=0
Password=
##PROJECT_GLOBAL_END

##PROGRAM_BEGIN_1
#PROJECT_OPTIONS_BEGIN
[Program]
Name=New Program

[VCP]
I2CPriority=5
SendSource=0
SendAlloc=1
ProtectWithPasswd=0
Password=
ScanOverrunStopsProgram=1
OutputRetentive=0
AutoStart=1
Com1Mode=1
Com1Baudrate=19200
Com1Data=0
Com2Mode=3
Com2Baudrate=19200
Com2Data=0
EthAbusEnable=1
EthModbusEnable=0
WANUrl=
PushEvent=0
PushUrl=
ModbusDelay=20
ModbusDeviceAddress=1
ModbusPLCDataModel=2
ModbusAddress=0
ModbusRegisterCount=1
ModbusCoilsArrayVar=
ModbusRegistersArrayVar=
PLCCoilVars=
PLCRegisterVars=
ModbusCoilAddresses=
ModbusRegisterAddresses=

[Misc Info]
MonitorHistorySpeed=10

[Hardware]
CPUUnit=10
VarAreaTyp0.7.0=0
VarAreaTyp0.7.1=0
VarAreaTyp0.7.2=0
VarAreaTyp0.7.3=0
VarAreaTyp0.7.4=0
VarAreaTyp0.7.5=0
Card1=35
Type1=0
NAD1=-1
VarPrefix1=gsm_

[Net]
CurrentNAD=-1
#PROJECT_OPTIONS_END

#DMVARSLIST_BEGIN
#DMVARSLIST_END

#MASKS_BEGIN
#MASKS_END

#CODE_BEGIN
// AllocGroupList="User Variables", "I/O Variables", "Constants", "Objects", "Analog clock", "Pacman", "Gsm demo", "Floor plan", "Time plot", "SolarTracker"
var constant
  CMD_EMPTY = 0; // {AllocGroup="Pacman"}
  CMD_RIGHT = 1; // {AllocGroup="Pacman"}
  CMD_LEFT = 2; // {AllocGroup="Pacman"}
  CMD_DOWN = 3; // {AllocGroup="Pacman"}
  CMD_UP = 4; // {AllocGroup="Pacman"}
  CMD_NEW_GAME = 5; // {AllocGroup="Pacman"}
  PACMAN_DX_STEP = 3; // Pacman x movement step in pixels (must be integer fraction of cell x size) {AllocGroup="Pacman"}
  PACMAN_DY_STEP = 3; // Pacman y movement step in pixels (must be integer fraction of cell y size) {AllocGroup="Pacman"}
  X0 = 40; // Labyrinth screen x offset in pixels {AllocGroup="Pacman"}
  Y0 = 120; // Labyrinth screen y offset in pixels {AllocGroup="Pacman"}
  COLUMNS = 19; // Number of matrix columns {AllocGroup="Pacman"}
  ROWS = 21; // Number of matrix rows {AllocGroup="Pacman"}
  CELL_SIZE_X = 30; // Matrix cell x size in pixels {AllocGroup="Pacman"}
  CELL_SIZE_Y = 30; // Matrix cell y size in pixels {AllocGroup="Pacman"}
  DELTA_X = 6; // Minimal x distance between pacman and object to eat (pixels) {AllocGroup="Pacman"}
  DELTA_Y = 6; // Minimal y distance between pacman and object to eat (pixels) {AllocGroup="Pacman"}
  TOTAL_DOTS = 186; // Total number of dots to eat {AllocGroup="Pacman"}
  IMG_CELL_EMPTY = 0; // Image representing  free cell {AllocGroup="Pacman"}
  IMG_CELL_WALL = 1; // Image representing wall {AllocGroup="Pacman"}
  IMG_CELL_DOT = 2; // {AllocGroup="Pacman"}
  IMG_CELL_BIGDOT = 3; // {AllocGroup="Pacman"}
  IMG_PACMAN_LEFT_OPENED = 0; // {AllocGroup="Pacman"}
  IMG_PACMAN_LEFT_CLOSED = 1; // {AllocGroup="Pacman"}
  IMG_PACMAN_RIGHT_OPENED = 2; // {AllocGroup="Pacman"}
  IMG_PACMAN_RIGHT_CLOSED = 3; // {AllocGroup="Pacman"}
  IMG_PACMAN_UP_OPENED = 4; // {AllocGroup="Pacman"}
  IMG_PACMAN_UP_CLOSED = 5; // {AllocGroup="Pacman"}
  IMG_PACMAN_DOWN_OPENED = 6; // {AllocGroup="Pacman"}
  IMG_PACMAN_DOWN_CLOSED = 7; // {AllocGroup="Pacman"}
  IMG_GHOST_EMPTY = 0; // {AllocGroup="Pacman"}
  IMG_GHOST_RIGHT = 1; // {AllocGroup="Pacman"}
  IMG_GHOST_LEFT = 2; // {AllocGroup="Pacman"}
  IMG_GHOST_GREY_RIGHT = 3; // {AllocGroup="Pacman"}
  IMG_GHOST_GREY_LEFT = 4; // {AllocGroup="Pacman"}
  GHOST_DX_STEP = 3; // Ghost x movement step in pixels (must be integer fraction of cell x size) {AllocGroup="Pacman"}
  GHOST_DY_STEP = 3; // Ghost y movement step in pixels (must be integer fraction of cell y size) {AllocGroup="Pacman"}
  MAX_COUNT = 10; // maximum number of harmonics (sine functions) {AllocGroup="Time plot"}
  PI = 3.1415926536; // {AllocGroup="Time plot"}
  ROOM_COUNT = 10; // {AllocGroup="Floor plan"}
  GAME_SPEED = 50; // Length of a single move [ms]. {AllocGroup="Pacman"}
var_end;

var
  score: int; default=0; // {AllocGroup="Pacman"}
  can_move: ARRAY[0..3] OF int; // {AllocGroup="Pacman"}
  game_over: bool; default=0; // {AllocGroup="Pacman"}
  new_game: bool; default=0; // {AllocGroup="Pacman"}
  t: timer = ( PT:=10000; TYPE:=OnDelay; BASE:=1000 ); // Timer indicating that ghosts are harmless (eatable) {AllocGroup="Pacman"}
  ghosts_eatable: int; default=0; // {AllocGroup="Pacman"}
  command: int; default=0; // Command indicating user input {AllocGroup="Pacman"}
  key: int; default=0; // Simulated key press {AllocGroup="Pacman"}
  pacman_x: int; // Pacman screen x position in pixels {AllocGroup="Pacman"}
  pacman_y: int; // Pacman screen y position in pixels {AllocGroup="Pacman"}
  pacman_img: int; default=0; // Current pacman image {AllocGroup="Pacman"}
  pacman_dx: int; // Current x step in pixels {AllocGroup="Pacman"}
  pacman_dy: int; // Current y step in pixels {AllocGroup="Pacman"}
  matrix: ARRAY[0..399] OF int; // Matrix representing labyrinth {AllocGroup="Pacman"}
  dots_left: int; // Number of dots left for eating {AllocGroup="Pacman"}
  ghost_count: int; default=4; // Number of ghosts {AllocGroup="Pacman"}
  ghost_x: ARRAY[0..9] OF int; // Ghost screen x position {AllocGroup="Pacman"}
  ghost_y: ARRAY[0..9] OF int; // Ghost screen y position {AllocGroup="Pacman"}
  ghost_img: ARRAY[0..9] OF int; // Current ghost image {AllocGroup="Pacman"}
  ghost_dx: ARRAY[0..9] OF int; // Current x step in pixels {AllocGroup="Pacman"}
  ghost_dy: ARRAY[0..9] OF int; // Current y step in pixels {AllocGroup="Pacman"}
  i: int; // {AllocGroup="Gsm demo"}
  call: bool; // Set to 1 for voice call activation. Will be reset by program immediately. {AllocGroup="Gsm demo"}
  send: bool; // Set to 1 for sms send. Will be reset by program immediately. {AllocGroup="Gsm demo"}
  ms: int; // {AllocGroup="Gsm demo"}
  incoming_call_anim: int; // {AllocGroup="Gsm demo"}
  incoming_voice_num: ARRAY[0..19] OF int; // {AllocGroup="Gsm demo"}
  incoming_sms_num: ARRAY[0..19] OF int; // {AllocGroup="Gsm demo"}
  incoming_number: ARRAY[0..19] OF int; // buffer for incoming phone number, ascii, zero terminated {AllocGroup="Gsm demo"}
  incoming_number_size: int; // number of incoming phone digits {AllocGroup="Gsm demo"}
  incoming_number_reading: bool; // flag indicating reading of incoming number {AllocGroup="Gsm demo"}
  incoming_message: ARRAY[0..159] OF int; // buffer for incoming message content, ascii, zero terminated {AllocGroup="Gsm demo"}
  incoming_message_size: int; // number of letters in incoming message {AllocGroup="Gsm demo"}
  incoming_message_reading: bool; // flag indicating reading of incoming message {AllocGroup="Gsm demo"}
  outgoing_number: ARRAY[0..19] OF int; // buffer for outgoing phone number, ascii, zero terminated {AllocGroup="Gsm demo"}
  number_write_index: int; // index of currently writing outgoing number {AllocGroup="Gsm demo"}
  outgoing_number_writing: bool; // flag indicating writing of outgoing number {AllocGroup="Gsm demo"}
  outgoing_call: bool; // set to make a call {AllocGroup="Gsm demo"}
  outgoing_message: ARRAY[0..159] OF int; // buffer for outgoing message content, ascii, zero terminated {AllocGroup="Gsm demo"}
  sms_write_index: int; // index of currently writing outgoing sms letter {AllocGroup="Gsm demo"}
  outgoing_message_writing: bool; // flag indicating writing of outgoing sms message {AllocGroup="Gsm demo"}
  send_message: bool; // set to send an sms {AllocGroup="Gsm demo"}
  alarm_state: int; // {AllocGroup="Objects"}
  analog_value: int; // {AllocGroup="Objects"}
  x: int; default=0; // degrees {AllocGroup="Time plot"}
  y: real; default=0; // {AllocGroup="Time plot"}
  fourier_y: real; default=0; // {AllocGroup="Time plot"}
  rnd_signal: real; default=0; // {AllocGroup="Time plot"}
  sine: ARRAY[0..9] OF real; // {AllocGroup="Time plot"}
  sum: real; default=0; // {AllocGroup="Time plot"}
  old_sum: real; default=0; // {AllocGroup="Time plot"}
  to_positive: int; default=0; // {AllocGroup="Time plot"}
  to_negative: int; default=0; // {AllocGroup="Time plot"}
  harmonics_count: int; default=9; // number of harmonics to use for Fourier expansion (0..9) {AllocGroup="Time plot"}
  amplitude: int; default=500; // {AllocGroup="Time plot"}
  position_x: int; default=100; // {AllocGroup="Objects"}
  position_y: int; default=300; // {AllocGroup="Objects"}
  hvac_timetable: ARRAY[0..1007] OF bool; // {AllocGroup="Floor plan"}
  th_measured: ARRAY[0..9] OF int; default=237; // {AllocGroup="Floor plan"}
  th_setpoint: ARRAY[0..9] OF int; default=240; // {AllocGroup="Floor plan"}
  th_active_mode: ARRAY[0..9] OF int; default=3; // {AllocGroup="Floor plan"}
  th_mode: ARRAY[0..9] OF int; default=1; // {AllocGroup="Floor plan"}
  th_active: ARRAY[0..9] OF int; default=3; // {AllocGroup="Floor plan"}
  th_max: ARRAY[0..9] OF bool; // {AllocGroup="Floor plan"}
  th_max_timer: ARRAY[0..9] OF int; // {AllocGroup="Floor plan"}
  th_max_preset: int; default=300; // {AllocGroup="Floor plan"}
  th_timetable_mux: ARRAY[0..2] OF int; // {AllocGroup="Floor plan"}
  th_mode_enable: ARRAY[0..9] OF int; default=3; // {AllocGroup="Floor plan"}
  th_setpoint_heat_active: ARRAY[0..9] OF int; default=220; // {AllocGroup="Floor plan"}
  th_setpoint_cool_active: ARRAY[0..9] OF int; default=250; // {AllocGroup="Floor plan"}
  th_setpoint_heat_idle: ARRAY[0..9] OF int; default=180; // {AllocGroup="Floor plan"}
  th_setpoint_cool_idle: ARRAY[0..9] OF int; default=280; // {AllocGroup="Floor plan"}
  th_setpoint_synchronize: ARRAY[0..9] OF int; default=1; // {AllocGroup="Floor plan"}
  th_bio_offset: int; // {AllocGroup="Floor plan"}
  th_bio_enable: ARRAY[0..9] OF bool; // {AllocGroup="Floor plan"}
  fc_speed: ARRAY[0..9] OF int; default=1; // {AllocGroup="Floor plan"}
  fc_limit: ARRAY[0..9] OF int; default=2; // {AllocGroup="Floor plan"}
  fc_valve: ARRAY[0..9] OF bool; // {AllocGroup="Floor plan"}
  fc_manual: ARRAY[0..9] OF bool; // {AllocGroup="Floor plan"}
  latitude: real; default=46; // Latitude of the place (degrees), north positive {AllocGroup="SolarTracker"}
  longitude: real; default=16; // Longitude of the place (degrees), east positive {AllocGroup="SolarTracker"}
  time_zone: real; default=1; // Difference between local time and Universal time (UT), in hours {AllocGroup="SolarTracker"}
  time_step: int; default=5; // 1, 2, 5, 10, 30 {AllocGroup="SolarTracker"}
  time_unit: int; default=1; // 0 - sec, 1 - min, 2 - hour {AllocGroup="SolarTracker"}
  time_dir: int; default=1; // -1 reverse time, 0 stop, 1 go forward in time {AllocGroup="SolarTracker"}
  simulation: bool; default=1; // 0 - real time from RTC, 1 - simulation {AllocGroup="SolarTracker"}
  show_grid: bool; default=1; // 0 - grid not visible, 1- grid visible {AllocGroup="SolarTracker"}
  sun_alt: real; // Sun altitude in degrees, 0 horizon, 90 zenith {AllocGroup="SolarTracker"}
  sun_az: real; // Sun azimuth, degrees, 0 north, 90 east... {AllocGroup="SolarTracker"}
  sun_x: int; // Sun x position for miniscada {AllocGroup="SolarTracker"}
  sun_y: int; // Sun y position for miniscada {AllocGroup="SolarTracker"}
  year: int; // {AllocGroup="SolarTracker"}
  month: int; // {AllocGroup="SolarTracker"}
  day: int; // {AllocGroup="SolarTracker"}
  hour: int; // {AllocGroup="SolarTracker"}
  minute: int; // {AllocGroup="SolarTracker"}
  second: int; // {AllocGroup="SolarTracker"}
  scan: int;
  rtc_hour_60: int; // {AllocGroup="Analog clock"}
  int_array: ARRAY[0..19] OF int; // {AllocGroup="Objects"}
  program_id: int; default=7872; // Identification number used for autodetection. Default value given here and inside mini scada xml must be equal.
  game_clock: bool; // Actual execution speed. {AllocGroup="Pacman"}
  game_clock_ms: int; // Counter for game clock [ms]. {AllocGroup="Pacman"}
var_end;

function main:void; language 'Structured Text';
  function analog_clock:void; language 'Structured Text';
  begin
    
    rtc_hour_60 := (rtc_hour % 12) * 5 + rtc_min/12;
    
  end;
  function floor_plan:void; language 'Structured Text';
  // AllocGroupList="User Variables"
  var
    i: int;
  var_end;

  begin
    
    // handle max timer
    
    if fp(clock_1s) then
      for i:=0 to ROOM_COUNT-1 do
    
        if fp(th_max[i]) and (th_max_timer[i]==0) then
          th_max_timer[i]:=th_max_preset;
        end_if;
    
        if th_max[i]==0 then
          th_max_timer[i]:=0;
        end_if;
    
        if th_max_timer[i]>0 then
          th_max_timer[i]:=th_max_timer[i]-1;
          if th_max_timer[i]==0 then
            th_max[i]:=0;
          end_if;
        end_if;
    
      end_for;
    end_if;
    
  end;
  function gsm_demo:void; language 'Structured Text';
    function VoiceAndSMSAPI:void; language 'Structured Text';
    begin
      // init receiving
      
      if fp(gsm_incoming_call) then // gsm_incoming_call - active while phone is ringing
        gsm_incoming_digit_data:=-1;
        gsm_incoming_digit_req:=1;
        incoming_number_size:=0;
        incoming_number_reading:=1;
      end_if;
      
      if fp(gsm_message_received) then // gsm_message_received - sms message received
        gsm_incoming_digit_data:=-1;
        gsm_incoming_digit_req:=1;
        incoming_number_size:=0;
        incoming_number_reading:=1;
        gsm_incoming_letter_data:=-1;
        gsm_incoming_letter_req:=1;
        incoming_message_size:=0;
        incoming_message_reading:=1;
      end_if;
      
      // read phone number from module
      
      if incoming_number_reading and gsm_incoming_digit_data<>-1 then
        incoming_number[incoming_number_size]:=gsm_incoming_digit_data;
        incoming_number_size:=incoming_number_size+1;
        if gsm_incoming_digit_data==0 or incoming_number_size>=20 then
          incoming_number_reading:=0;
        else
          gsm_incoming_digit_data:=-1;
          gsm_incoming_digit_req:=1;
        end_if;
      end_if;
      
      // read sms message from module
      
      if incoming_message_reading and gsm_incoming_letter_data<>-1 then
        incoming_message[incoming_message_size]:=gsm_incoming_letter_data;
        incoming_message_size:=incoming_message_size+1;
        if gsm_incoming_letter_data==0 or incoming_number_size>=160 then
          incoming_message_reading:=0;
        else
          gsm_incoming_letter_data:=-1;
          gsm_incoming_letter_req:=1;
        end_if;
      end_if;
      
      // init sending
      
      if fp(outgoing_call) then
        gsm_outgoing_index:=-1;
        gsm_outgoing_digit_ack:=1;
        number_write_index:=0;
        outgoing_number_writing:=1;
      end_if;
      
      if fp(send_message) then
        gsm_outgoing_index:=-1;
        gsm_outgoing_digit_ack:=1;
        number_write_index:=0;
        outgoing_number_writing:=1;
        sms_write_index:=0;
        gsm_outgoing_letter_ack:=1;
        outgoing_message_writing:=1;
      end_if;
      
      // write gsm number to module
      
      if outgoing_number_writing and gsm_outgoing_digit_ack=1 then
        gsm_outgoing_digit_data:=outgoing_number[number_write_index];
        gsm_outgoing_digit_ack:=-1;
        gsm_outgoing_digit_req:=1;
        number_write_index:=number_write_index+1;
        if gsm_outgoing_digit_data==0 or number_write_index>=20 then
          outgoing_number_writing:=0;
        end_if;
      end_if;
      
      // write sms message to module
      
      if outgoing_message_writing and gsm_outgoing_letter_ack=1 then
        gsm_outgoing_letter_data:=outgoing_message[sms_write_index];
        gsm_outgoing_letter_ack:=-1;
        gsm_outgoing_letter_req:=1;
        sms_write_index:=sms_write_index+1;
        if gsm_outgoing_letter_data==0 or sms_write_index>=160 then
          outgoing_message_writing:=0;
        end_if;
      end_if;
      
      // when number is transfered, make a call
      
      if fp(outgoing_call and not(outgoing_number_writing)) then
        gsm_outgoing_call_req:=1;
        outgoing_call:=0;
      end_if;
      
      // when number and message are transfered, initiate message sending
      
      if fp(send_message and not(outgoing_number_writing) and not(outgoing_message_writing)) then
        gsm_outgoing_sms_req:=1;
        send_message:=0;
      end_if;
      
    end;
  begin
    /*****************************************************************************************
      Application:  GsmPlcDemo
      Requires:     CyBro-2, GSM-1 v3.1
      Description:  This example shows how to read and write GSM-1 module voice and sms phone
                    numbers, as well as sms contents from CyBro.
    
      To prepare GSM-1:
    
        1. Open GSM-1 cover, insert SIM card.
    
      To run this application:
    
        2. Power on, Hardware Setup, autodetect, Ok.
        3. Press Start.
    
      To configure GSM module:
    
        4. Open GsmPlcDemo.ini with notepad, write SimPin if not disabled and send to GSM-1
           using GsmLoader.
    
      To check SMS and voice call functionality:
    
        5. Replace example phone number +385919798378 (2 times complete and 9 numbers in
           incoming call check) in this program with your mobile phone number and press start.
    
      To check SMS functionality:
    
        6. Open online monitor and set variable send to 1 for send sms (will be reset
           immediately by program).
           Sms "Hello, world!" will be sent to your mobile phone.
    
      To check voice call functionality:
    
        7. Open online monitor and set variable call to 1 for activate voice call (will be reset
           immediately by program).  Your phone will ring.
    
      For more details, check GSM-1 User Manual.
    
      Note: For this user program example COM2 port should be configured as free programmable.
    
    *****************************************************************************************/
    
    if first_scan then
      com_select(2); // select COM2
      dprns(0,0,0,'+385919798378\00'); // replace with your mobile phone number
      dprns(0,20,0,'Hello, world!\00'); // writing string to com2 tx buffer
      for i:=0 to 19 do
        outgoing_number[i]:=tx_bufrd(i); // copy from tx buffer to API buffer
      end_for;
      for i:=0 to 159 do
        outgoing_message[i]:=tx_bufrd(i+20); // copy to API buffer
      end_for;
    end_if;
    
    if fp(clock_1s) or fn(clock_1s) then
      incoming_call_anim:=gsm_incoming_call*((incoming_call_anim) mod 4 + 1);
    end_if;
    
    // set incoming voice number
    if (gsm_incoming_call) then
      for i:=0 to 19 do
        incoming_voice_num[i]:=incoming_number[i];
      end_for;
    else
      for i:=0 to 19 do
        incoming_voice_num[i]:=0;
      end_for;
    end_if;
    
    // set incoming sms number
    if (gsm_message_received) then
      for i:=0 to 19 do
        incoming_sms_num[i]:=incoming_number[i];
      end_for;
    end_if;
    
    // send sms
    if fp(send) then
      send_message:=1;
      send:=0;
    end_if;
    
    // outgoing voice call
    if fp(call) then
      outgoing_call:=1;
      call:=0;
    end_if;
    
    VoiceAndSMSAPI();
    
  end;
  function pacman:void; language 'Structured Text';
    function move_pacman:void; language 'Structured Text';
    // AllocGroupList="User Variables"
    var
      imove: int;
      dx: int;
      dy: int;
      hit: int;
    var_end;

    begin
      //************************
      // Move Pacman
      //************************
      
      if fp(game_clock) then
      
        // check for game start command
        if command<>CMD_EMPTY then
          if command=CMD_NEW_GAME then new_game:=TRUE; end_if;
          if game_over then
            command:=CMD_EMPTY;
           end_if;
        end_if;
      
        dx:=pacman_dx;
        dy:=pacman_dy;
      
        if command<>CMD_EMPTY then
          // try to move in user input direction
          case command of
            CMD_LEFT:
                  dx:=-PACMAN_DX_STEP;
                  dy:=0;
            CMD_RIGHT:
                  dx:=PACMAN_DX_STEP;
                  dy:=0;
            CMD_UP:
                  dx:=0;
                  dy:=-PACMAN_DY_STEP;
            CMD_DOWN:
                  dx:=0;
                  dy:=PACMAN_DY_STEP;
          end_case;
      
          hit := hit_wall(pacman_x, pacman_y, 2*dx, 2*dy);
          if (hit = 0) then //no collision, move to new position
            command := CMD_EMPTY;
          else // cannot move in user direction, continue in previous direction
            dx:=pacman_dx;
            dy:=pacman_dy;
          end_if;
        end_if;
      
        hit := hit_wall(pacman_x, pacman_y, dx, dy);
        if (hit = 0) then //no collision, move to new position
          pacman_x := pacman_x + dx;
          pacman_y := pacman_y + dy;
        else
          command := CMD_EMPTY;
        end_if;
      
        imove:=0;
        if (dx<0) and (dy=0) then imove:=CMD_LEFT; end_if;
        if (dx>0) and (dy=0) then imove:=CMD_RIGHT; end_if;
        if (dx=0) and (dy<0) then imove:=CMD_UP; end_if;
        if (dx=0) and (dy>0) then imove:=CMD_DOWN; end_if;
      
        // animate image
        case imove of
          CMD_LEFT:// left
            if pacman_img = IMG_PACMAN_LEFT_OPENED then
              pacman_img := IMG_PACMAN_LEFT_CLOSED;
            else
              pacman_img := IMG_PACMAN_LEFT_OPENED;
            end_if;
          CMD_RIGHT:// right
            if pacman_img = IMG_PACMAN_RIGHT_OPENED then
              pacman_img := IMG_PACMAN_RIGHT_CLOSED;
            else
              pacman_img := IMG_PACMAN_RIGHT_OPENED;
            end_if;
          CMD_UP:// up
            if pacman_img = IMG_PACMAN_UP_OPENED then
              pacman_img := IMG_PACMAN_UP_CLOSED;
            else
              pacman_img := IMG_PACMAN_UP_OPENED;
            end_if;
          CMD_DOWN:// down
            if pacman_img = IMG_PACMAN_DOWN_OPENED then
              pacman_img := IMG_PACMAN_DOWN_CLOSED;
            else
              pacman_img := IMG_PACMAN_DOWN_OPENED;
            end_if;
        end_case;
      
        pacman_dx:=dx;
        pacman_dy:=dy;
      end_if;
      
    end;
    function move_ghosts:void; language 'Structured Text';
    // AllocGroupList="User Variables"
    var
      k: int;
      i: int;
      dx: int;
      dy: int;
      cnt: int;
      rnd_num: int;
      hit: int;
    var_end;

    begin
      //************************
      // Move ghosts
      //************************
      
      if fp(game_clock) then
      
        for k := 0 to ghost_count - 1 do
      
          for i:=0 to 3 do can_move[i] := 0; end_for;
          // try all directions and remember available directions
          cnt := 0;
          while (cnt<4) do
            case cnt of
              0: dx := GHOST_DX_STEP;
                 dy := 0;
              1: dx := -GHOST_DX_STEP;
                 dy := 0;
              2: dx := 0;
                 dy := GHOST_DY_STEP;
              3: dx := 0;
                 dy := -GHOST_DY_STEP;
            end_case;
      
            hit := hit_wall(ghost_x[k], ghost_y[k], dx, dy);
            if (hit = 0) then // no collision
              can_move[cnt]:=1;
            end_if;
      
            cnt := cnt + 1;
          end_while;
      
      
          dx := ghost_dx[k];
          dy := ghost_dy[k];
          rnd_num := int(random(4)) + k mod ghost_count + int(random(7));
      
          i:=-1;
          // moving in x (left or right)
          if (dy=0) then
            // can move up and down
            if (can_move[2]=1) and (can_move[3]=1) then
               i:=rnd_num mod 2 + 2;
               if (dx>0) and (can_move[0]=1) then
                 if (rnd_num mod 3=0) then i:=0; end_if;
               end_if;
               if (dx<0) and (can_move[1]=1) then
                 if (rnd_num mod 3=0) then i:=1; end_if;
               end_if;
            end_if;
            // can move down
            if (can_move[2]=1) and (can_move[3]=0) then
               if (rnd_num mod 2=0) then i:=2; end_if;
               if (dx>0) and (can_move[0]=1) then
                 if (rnd_num mod 3=0) then i:=0; end_if;
               end_if;
               if (dx<0) and (can_move[1]=1) then
                 if (rnd_num mod 3=0) then i:=1; end_if;
               end_if;
            end_if;
            // can move up
            if (can_move[2]=0) and (can_move[3]=1) then
               if (rnd_num mod 2=0) then i:=3; end_if;
               if (dx>0) and (can_move[0]=1) then
                 if (rnd_num mod 3=0) then i:=0; end_if;
               end_if;
               if (dx<0) and (can_move[1]=1) then
                 if (rnd_num mod 3=0) then i:=1; end_if;
               end_if;
            end_if;
            // cannot move neither up nor down
            if (can_move[2]=0) and (can_move[3]=0) then
              if (dx>0) and (can_move[0]=0) then i:=1; end_if;
              if (dx<0) and (can_move[1]=0) then i:=0; end_if;
            end_if;
          end_if;
      
          // moving in y (up or down)
          if (dx=0) then
            // can move left and right
            if (can_move[0]=1) and (can_move[1]=1) then
               i:=rnd_num mod 2;
               if (dy>0) and (can_move[2]=1) then
                 if (rnd_num mod 3=0) then i:=2; end_if;
               end_if;
               if (dy<0) and (can_move[3]=1) then
                 if (rnd_num mod 3=0) then i:=3; end_if;
               end_if;
            end_if;
            // can move right
            if (can_move[0]=1) and (can_move[1]=0) then
               if (rnd_num mod 2=0) then i:=1; end_if;
               if (dy>0) and (can_move[2]=1) then
                 if (rnd_num mod 3=0) then i:=2; end_if;
               end_if;
               if (dy<0) and (can_move[3]=1) then
                 if (rnd_num mod 3=0) then i:=3; end_if;
               end_if;
            end_if;
            // can move left
            if (can_move[0]=0) and (can_move[1]=1) then
               if (rnd_num mod 2=0) then i:=1; end_if;
               if (dy>0) and (can_move[2]=1) then
                 if (rnd_num mod 2=0) then i:=2; end_if;
               end_if;
               if (dy<0) and (can_move[3]=1) then
                 if (rnd_num mod 2=0) then i:=3; end_if;
               end_if;
            end_if;
            // cannot move neither left nor right
            if (can_move[0]=0) and (can_move[1]=0) then
              if (dy>0) and (can_move[2]=0) then i:=3; end_if;
              if (dy<0) and (can_move[3]=0) then i:=2; end_if;
            end_if;
          end_if;
      
          case i of
            0:dx:=GHOST_DX_STEP;
              dy:=0;
              ghost_img[k]:=IMG_GHOST_RIGHT;
            1:dx:=-GHOST_DX_STEP;
              dy:=0;
              ghost_img[k]:=IMG_GHOST_LEFT;
            2:dx:=0;
              dy:=GHOST_DY_STEP;
            3:dx:=0;
              dy:=-GHOST_DY_STEP;
          end_case;
      
          if (ghosts_eatable=1) and (ghost_img[k]<>IMG_GHOST_EMPTY) then
            if (ghost_img[k]=IMG_GHOST_RIGHT) then ghost_img[k]:=IMG_GHOST_GREY_RIGHT; end_if;
            if (ghost_img[k]=IMG_GHOST_LEFT) then ghost_img[k]:=IMG_GHOST_GREY_LEFT; end_if;
          end_if;
      
          ghost_dx[k] := dx;
          ghost_dy[k] := dy;
      
          ghost_x[k] := ghost_x[k] + dx;
          ghost_y[k] := ghost_y[k] + dy;
      
        end_for;
      end_if;
      
    end;
    function initialize:void; language 'Structured Text';
    // AllocGroupList="User Variables"
    var
      j: int;
      k: int;
      i: int;
    var_end;

    begin
      //************************
      // Initialize
      //************************
      
      command := CMD_EMPTY;
      game_over := FALSE;
      dots_left := TOTAL_DOTS;
      score := 0;
      ghosts_eatable := 0;
      
      // default pacman position
      pacman_x := 9 * CELL_SIZE_X + X0;
      pacman_y := 11 * CELL_SIZE_Y + Y0;
      pacman_dx := 0;
      pacman_dy := 0;
      pacman_img := IMG_PACMAN_LEFT_CLOSED;
      
      for i:=0 to ghost_count-1 do
        ghost_x[i]:=9 * CELL_SIZE_X + X0;
        ghost_y[i]:=9 * CELL_SIZE_Y + Y0 - 2 * GHOST_DY_STEP;
        ghost_img[i]:=IMG_GHOST_RIGHT;
        ghost_dx[i]:=0;
        ghost_dy[i]:=-GHOST_DY_STEP;
      end_for;
      
      for i:=0 to ROWS-1 do
        for j:=0 to COLUMNS-1 do
          k:=i*COLUMNS+j;
          matrix[k]:=IMG_CELL_DOT;
          if (i=0) or (i=ROWS-1) then matrix[k]:=1; end_if;
          if (j=0) or (j=COLUMNS-1) then matrix[k]:=1; end_if;
        end_for;
      end_for;
      
      // bigdots
      matrix[39]:=IMG_CELL_BIGDOT;
      matrix[55]:=IMG_CELL_BIGDOT;
      matrix[286]:=IMG_CELL_BIGDOT;
      matrix[302]:=IMG_CELL_BIGDOT;
      
      // empty
      matrix[218]:=IMG_CELL_EMPTY;
      matrix[133]:=IMG_CELL_EMPTY;
      matrix[134]:=IMG_CELL_EMPTY;
      matrix[135]:=IMG_CELL_EMPTY;
      matrix[149]:=IMG_CELL_EMPTY;
      matrix[150]:=IMG_CELL_EMPTY;
      matrix[151]:=IMG_CELL_EMPTY;
      matrix[209]:=IMG_CELL_EMPTY;
      matrix[210]:=IMG_CELL_EMPTY;
      matrix[211]:=IMG_CELL_EMPTY;
      matrix[225]:=IMG_CELL_EMPTY;
      matrix[226]:=IMG_CELL_EMPTY;
      matrix[227]:=IMG_CELL_EMPTY;
      //walls
      
      //row 1
      matrix[28]:=IMG_CELL_WALL;
      //row 2
      matrix[40]:=IMG_CELL_WALL;
      matrix[41]:=IMG_CELL_WALL;
      matrix[43]:=IMG_CELL_WALL;
      matrix[44]:=IMG_CELL_WALL;
      matrix[45]:=IMG_CELL_WALL;
      matrix[47]:=IMG_CELL_WALL;
      matrix[49]:=IMG_CELL_WALL;
      matrix[50]:=IMG_CELL_WALL;
      matrix[51]:=IMG_CELL_WALL;
      matrix[53]:=IMG_CELL_WALL;
      matrix[54]:=IMG_CELL_WALL;
      //row 4
      matrix[78]:=IMG_CELL_WALL;
      matrix[79]:=IMG_CELL_WALL;
      matrix[81]:=IMG_CELL_WALL;
      matrix[83]:=IMG_CELL_WALL;
      matrix[84]:=IMG_CELL_WALL;
      matrix[85]:=IMG_CELL_WALL;
      matrix[86]:=IMG_CELL_WALL;
      matrix[87]:=IMG_CELL_WALL;
      matrix[89]:=IMG_CELL_WALL;
      matrix[91]:=IMG_CELL_WALL;
      matrix[92]:=IMG_CELL_WALL;
      //row 5
      matrix[100]:=IMG_CELL_WALL;
      matrix[104]:=IMG_CELL_WALL;
      matrix[108]:=IMG_CELL_WALL;
      //row 6
      matrix[115]:=IMG_CELL_WALL;
      matrix[116]:=IMG_CELL_WALL;
      matrix[117]:=IMG_CELL_WALL;
      matrix[119]:=IMG_CELL_WALL;
      matrix[120]:=IMG_CELL_WALL;
      matrix[121]:=IMG_CELL_WALL;
      matrix[123]:=IMG_CELL_WALL;
      matrix[125]:=IMG_CELL_WALL;
      matrix[126]:=IMG_CELL_WALL;
      matrix[127]:=IMG_CELL_WALL;
      matrix[129]:=IMG_CELL_WALL;
      matrix[130]:=IMG_CELL_WALL;
      matrix[131]:=IMG_CELL_WALL;
      //row 7
      matrix[136]:=IMG_CELL_WALL;
      matrix[138]:=IMG_CELL_WALL;
      matrix[146]:=IMG_CELL_WALL;
      matrix[148]:=IMG_CELL_WALL;
      //row 8
      matrix[153]:=IMG_CELL_WALL;
      matrix[154]:=IMG_CELL_WALL;
      matrix[155]:=IMG_CELL_WALL;
      matrix[157]:=IMG_CELL_WALL;
      matrix[159]:=IMG_CELL_WALL;
      matrix[160]:=IMG_CELL_WALL;
      matrix[162]:=IMG_CELL_WALL;
      matrix[163]:=IMG_CELL_WALL;
      matrix[165]:=IMG_CELL_WALL;
      matrix[167]:=IMG_CELL_WALL;
      matrix[168]:=IMG_CELL_WALL;
      matrix[169]:=IMG_CELL_WALL;
      //row 9
      matrix[178]:=IMG_CELL_WALL;
      matrix[182]:=IMG_CELL_WALL;
      //row 10
      matrix[191]:=IMG_CELL_WALL;
      matrix[192]:=IMG_CELL_WALL;
      matrix[193]:=IMG_CELL_WALL;
      matrix[195]:=IMG_CELL_WALL;
      matrix[197]:=IMG_CELL_WALL;
      matrix[198]:=IMG_CELL_WALL;
      matrix[199]:=IMG_CELL_WALL;
      matrix[200]:=IMG_CELL_WALL;
      matrix[201]:=IMG_CELL_WALL;
      matrix[203]:=IMG_CELL_WALL;
      matrix[205]:=IMG_CELL_WALL;
      matrix[206]:=IMG_CELL_WALL;
      matrix[207]:=IMG_CELL_WALL;
      //row 11
      matrix[212]:=IMG_CELL_WALL;
      matrix[214]:=IMG_CELL_WALL;
      matrix[222]:=IMG_CELL_WALL;
      matrix[224]:=IMG_CELL_WALL;
      //row 12
      matrix[229]:=IMG_CELL_WALL;
      matrix[230]:=IMG_CELL_WALL;
      matrix[231]:=IMG_CELL_WALL;
      matrix[233]:=IMG_CELL_WALL;
      matrix[235]:=IMG_CELL_WALL;
      matrix[236]:=IMG_CELL_WALL;
      matrix[237]:=IMG_CELL_WALL;
      matrix[238]:=IMG_CELL_WALL;
      matrix[239]:=IMG_CELL_WALL;
      matrix[241]:=IMG_CELL_WALL;
      matrix[243]:=IMG_CELL_WALL;
      matrix[244]:=IMG_CELL_WALL;
      matrix[245]:=IMG_CELL_WALL;
      //row 13
      matrix[256]:=IMG_CELL_WALL;
      //row 14
      matrix[268]:=IMG_CELL_WALL;
      matrix[269]:=IMG_CELL_WALL;
      matrix[271]:=IMG_CELL_WALL;
      matrix[272]:=IMG_CELL_WALL;
      matrix[273]:=IMG_CELL_WALL;
      matrix[275]:=IMG_CELL_WALL;
      matrix[277]:=IMG_CELL_WALL;
      matrix[278]:=IMG_CELL_WALL;
      matrix[279]:=IMG_CELL_WALL;
      matrix[281]:=IMG_CELL_WALL;
      matrix[282]:=IMG_CELL_WALL;
      //row 15
      matrix[288]:=IMG_CELL_WALL;
      matrix[300]:=IMG_CELL_WALL;
      //row 16
      matrix[305]:=IMG_CELL_WALL;
      matrix[307]:=IMG_CELL_WALL;
      matrix[309]:=IMG_CELL_WALL;
      matrix[311]:=IMG_CELL_WALL;
      matrix[312]:=IMG_CELL_WALL;
      matrix[313]:=IMG_CELL_WALL;
      matrix[314]:=IMG_CELL_WALL;
      matrix[315]:=IMG_CELL_WALL;
      matrix[317]:=IMG_CELL_WALL;
      matrix[319]:=IMG_CELL_WALL;
      matrix[321]:=IMG_CELL_WALL;
      //row 17
      matrix[328]:=IMG_CELL_WALL;
      matrix[332]:=IMG_CELL_WALL;
      matrix[336]:=IMG_CELL_WALL;
      //row 18
      matrix[344]:=IMG_CELL_WALL;
      matrix[345]:=IMG_CELL_WALL;
      matrix[346]:=IMG_CELL_WALL;
      matrix[347]:=IMG_CELL_WALL;
      matrix[348]:=IMG_CELL_WALL;
      matrix[349]:=IMG_CELL_WALL;
      matrix[351]:=IMG_CELL_WALL;
      matrix[353]:=IMG_CELL_WALL;
      matrix[354]:=IMG_CELL_WALL;
      matrix[355]:=IMG_CELL_WALL;
      matrix[356]:=IMG_CELL_WALL;
      matrix[357]:=IMG_CELL_WALL;
      matrix[358]:=IMG_CELL_WALL;
      
    end;
    function check_eating:void; language 'Structured Text';
    // AllocGroupList="User Variables"
    var
      index: int;
      j: int;
      i: int;
      k: int;
      dx: int;
      dy: int;
    var_end;

    begin
      //************************
      // Check for eating
      //************************
      
        // calc matrix position of center
        i := (pacman_y - Y0 + CELL_SIZE_Y / 2) / CELL_SIZE_Y;
        j := (pacman_x - X0 + CELL_SIZE_X / 2) / CELL_SIZE_X;
        index := i * COLUMNS + j;
      
        // if dot is near then eat it
        if (matrix[index] > IMG_CELL_WALL) then
          dx := j * CELL_SIZE_X + X0 - pacman_x;
          dy := i * CELL_SIZE_Y + Y0 - pacman_y;
          if dx < 0 then dx := - dx; end_if;
          if dy < 0 then dy := - dy; end_if;
          if (dx < DELTA_X) and (dy < DELTA_Y) then
            if game_over=0 then  score := score + 1; end_if;
            dots_left := dots_left - 1;
            cybro_qx00:=!cybro_qx00; // click sound
            if (matrix[index] = IMG_CELL_BIGDOT) then
              ghosts_eatable := 1;
              t.in := 1;
            end_if;
            matrix[index] := IMG_CELL_EMPTY;
          end_if;
        end_if;
      
        // if ghost is near then eat him or finish game
        for k:=0 to ghost_count-1 do
          dx := (ghost_x[k]-pacman_x);
          dy := (ghost_y[k]-pacman_y);
          if dx < 0 then dx := - dx; end_if;
          if dy < 0 then dy := - dy; end_if;
          if (dx < 3*DELTA_X) and (dy < 3*DELTA_Y) then
            if (ghost_img[k] = IMG_GHOST_GREY_LEFT) or
               (ghost_img[k] = IMG_GHOST_GREY_RIGHT) then
              score := score + 20;
              cybro_qx00:=!cybro_qx00; // click sound
              ghost_img[k] := IMG_GHOST_EMPTY;
            else
              if (ghost_img[k] <> IMG_GHOST_EMPTY) then
                game_over := TRUE;
              end_if;
            end_if;
          end_if;
        end_for;
      
        if dots_left <= 0 then game_over := TRUE; end_if;
    end;
    function hit_wall(x,y,dx,dy:int):int; language 'Structured Text';
    // AllocGroupList="User Variables"
    var
      index_00: int;
      index_11: int;
      index_10: int;
      index_01: int;
      i: int;
      j: int;
    var_end;

    begin
        result := 0;
      
        x := x + dx;
        y := y + dy;
      
        // calc matrix position of an upper left corner
        i := (y - Y0) / CELL_SIZE_Y;
        j := (x - X0) / CELL_SIZE_X;
        index_00 := i * COLUMNS + j;
      
        // calc matrix position of an upper right corner
        i := (y - Y0) / CELL_SIZE_Y;
        j := (x + CELL_SIZE_X - X0 - 1) / CELL_SIZE_X;
        index_01 := i * COLUMNS + j;
      
        // calc matrix position of an lower left corner
        i := (y + CELL_SIZE_Y - Y0 - 1) / CELL_SIZE_Y;
        j := (x - X0) / CELL_SIZE_X;
        index_10 := i * COLUMNS + j;
      
        // calc matrix position of a lower right corner
        i := (y + CELL_SIZE_Y - Y0 - 1) / CELL_SIZE_Y;
        j := (x + CELL_SIZE_X - X0 - 1) / CELL_SIZE_X;
        index_11 := i * COLUMNS + j;
      
        // if wall is hit set result
        if (matrix[index_00] = IMG_CELL_WALL) or
           (matrix[index_01] = IMG_CELL_WALL) or
           (matrix[index_10] = IMG_CELL_WALL) or
           (matrix[index_11] = IMG_CELL_WALL) then
          result := 1;
        end_if;
      
    end;
    function alternate_input:void; language 'Structured Text';
    begin
      // if you have operator panel with remote input,
      // uncomment these lines to play with a remote
      
      //  case op00_ir_command of
      //    1169: command:=CMD_LEFT; //left
      //    1204: command:=CMD_RIGHT; //right
      //    1168: command:=CMD_UP; //up
      //    1202: command:=CMD_DOWN; //down
      //    1164: command:=CMD_NEW_GAME;
      //  end_case;
      //  op00_ir_command:=0;
      
    end;
    function random(limit:long):long; language 'Structured Text';
    // AllocGroupList="User Variables"
    var static
      last_result: long; default=0;
    var_end;

    begin
        /*
          function random(limit: long): long;
          Description:
            Simple pseudo random number generator
        */
        result := (last_result + (rtc_sec + 1) * (rtc_min + 1) * (scan_time + scan_frequency)) % limit;
        last_result := result;
      
    end;
  begin
    
    if first_scan or new_game then
      new_game:=FALSE;
      initialize();
    end_if;
    
    if fp(t.q) then
      t.in := 0;
      ghosts_eatable := 0;
    end_if;
    
    game_clock:=((2*game_clock_ms)>GAME_SPEED);
    game_clock_ms:=(game_clock_ms+scan_time)%GAME_SPEED;
    
    alternate_input();
    move_pacman();
    move_ghosts();
    check_eating();
    
  end;
  function timeplot:void; language 'Structured Text';
  // AllocGroupList="User Variables"
  var
    n: int;
    i: int;
  var_end;

    function sin(angle_deg:int):real; language 'Structured Text';
    // AllocGroupList="User Variables"
    var
      x2: real;
      x: real;
      sign: int;
      angle: int;
      q: int;
    var_end;

    begin
      /*
        Sine of an angle (in degrees) by taylor series expansion
        and using symmetry of sine for 0..90 deg, acurate to almost
        4 decimals at 90deg
        sin(x) = x - (x^3)/3! + (x^5)/5! - (x^7)/7! + ...
      */
      
      angle:=angle_deg;
      
      angle:=angle mod 360;
      if angle<0 then
        angle:=angle+360;
      end_if;
      
      q:=angle/90;
      angle:=angle mod 90;
      
      if (q>1) then
        sign:=-1;
      else
        sign:=1;
      end_if;
      
      if (q=1) or (q=3) then
        angle:=90-angle;
      end_if;
      
      x:=3.1415926536*angle/180.0;
      x2:=x*x;
      
      result:=sign*x*(1-x2*(1-x2*(1-x2/42)/20)/6);
    end;
    function random(limit:long):long; language 'Structured Text';
    // AllocGroupList="User Variables"
    var static
      last_result: long; default=0;
    var_end;

    begin
       /*
          function random(limit: long): long;
          Description:
            Simple pseudo random number generator
        */
        result := (last_result + (rtc_sec + 1) * (rtc_min + 1) * (scan_time + scan_frequency)) % limit;
        last_result := result;
      
      
    end;
  begin
    
    if first_scan then
      x:=0;
      y:=0;
      fourier_y:=0;
      rnd_signal:=0;
      harmonics_count:=MAX_COUNT;
    end_if;
    
    //original signal, square wave
    if (((10*x+1) mod 360)<180) then
      y:=amplitude;
    else
      y:=-amplitude;
    end_if;
    
    //fourier expansion
    sum:=0;
    for i:=0 to MAX_COUNT-1 do
      n:=2*i+1;
      sine[i]:=4.0/PI*real(amplitude)/n*sin(10*n*x);
      if i<harmonics_count then
        sum:=sum+sine[i];
      end_if;
    end_for;
    fourier_y:=sum;
    
    if fp(clock_1s) then
      //random periodic signal
      old_sum:=rnd_signal;
      rnd_signal:=100*sin(10*x)+random(41)-20;
      sum:=rnd_signal;
      //set alarms
      if (old_sum<=0) and (sum>0) then to_positive:=1; end_if;
      if (old_sum>=0) and (sum<0) then to_negative:=1; end_if;
    end_if;
    
    //advance x (1sec equals one degree)
    if fp(clock_1s) then
      x:=(x+1) mod 360;
    end_if;
    
    //hold alarms for a short while and then reset them
    if fp(clock_100ms) then
      if to_positive>0 then to_positive:=(to_positive+1) mod 10; end_if;
      if to_negative>0 then to_negative:=(to_negative+1) mod 10; end_if;
    end_if;
    
  end;
  function solar_tracker:void; language 'Structured Text';
  // AllocGroupList="User Variables"
  var
    r: real;
  var_end;

    function sin(x:real):real; language 'Structured Text';
    // AllocGroupList="User Variables"
    var
      y: real;
      k: int;
    var_end;

    begin
        /*
      
          function sin(x:real):real
      
          Calculates sine of x (in radians)
      
          Precision is best in -pi/2..-pi/2 interval, getting lower for larger x
          due to IEEE 754 4-byte representation of real numbers (limited to about
          8 significant digits).
      
          I. Skokic, November 2012
      
        */
      
        // remember sign
        if x<0 then k:=-1; else k:=1; end_if;
      
        // reduce to -2*pi..2*pi
        x:=x*0.1591549430919;          // /(2*pi)
        x:=(x-int(x))*6.2831853071796; // *2*pi
      
        // y=abs(x)
        if x<0 then y:=-x; else y:=x; end_if;
      
        // reduce to -pi/2..pi/2 using symmetry
        if y>4.712388980385 then       // 3/2*pi
          x:=x-k*6.2831853071796;      // 2*pi
          k:=1;
        elsif y>1.5707963267949 then   // pi/2
          x:=x-k*3.1415926536;         // pi
          k:=-1;
        else
          k:=1;
        end_if;
      
        //calc sin(x) by Taylor expansion around 0, sin(x)=x - x^3/3! + x^5/5! - x^7/7! + ...
        y:=x*x;
        result:=k*x*(1+y*(-0.1666666664+y*(0.0083333315+y*(-0.0001984090+y*(0.0000027526+y*(-0.0000000239))))));
      
    end;
    function cos(x:real):real; language 'Structured Text';
    // AllocGroupList="User Variables"
    var
      y: real;
      k: int;
    var_end;

    begin
      /*
      
          function cos(x:real):real
      
          Calculates cosine of x (in radians)
      
          Precision is best in -pi/2..-pi/2 interval, getting lower for larger x
          due to IEEE 754 4-byte representation of real numbers (limited to about
          8 significant digits).
          This implementation uses sin(x+pi/2)=cos(x) to calculate cos(x)
      
          I. Skokic, November 2012
      
      */
      
        x:=x+1.5707963267949;  // add pi/2 to x and then just calculate sin(x)
      
        // remember sign
        if x<0 then k:=-1; else k:=1; end_if;
      
        // reduce to -2*pi..2*pi
        x:=x*0.1591549430919;          // /(2*pi)
        x:=(x-int(x))*6.2831853071796; // *2*pi
      
        // y=abs(x)
        if x<0 then y:=-x; else y:=x; end_if;
      
        // reduce to -pi/2..pi/2 using symmetry
        if y>4.712388980385 then       // 3/2*pi
          x:=x-k*6.2831853071796;      // 2*pi
          k:=1;
        elsif y>1.5707963267949 then   // pi/2
          x:=x-k*3.1415926536;         // pi
          k:=-1;
        else
          k:=1;
        end_if;
      
        //calc sin(x) by Taylor expansion around 0, sin(x)=x - x^3/3! + x^5/5! - x^7/7! + ...
        y:=x*x;
        result:=k*x*(1+y*(-0.1666666664+y*(0.0083333315+y*(-0.0001984090+y*(0.0000027526+y*(-0.0000000239))))));
      
    end;
    function atan2(y,x:real):real; language 'Structured Text';
    // AllocGroupList="User Variables"
    var
      k: int;
      r: real;
      y_over_x: real;
      kk: int;
    var_end;

    begin
      /*
         function atan2(y,x:real):real;
      
         Quadrant-correct atan(y/x) in radians.
         Should be correct to few decimals, enough for most applications.
      
         I. Skokic, November 2012
      */
      
        if y<0 then k:=-1; else k:=1; end_if;
        if x=0 then
          // return pi/2
          r:=1.5707963267949;
        else
          // or calculate r=atan(y/x)
          kk:=1;
          y_over_x:=y/x;
          if(y_over_x<0) then
             kk:=-1;
             y_over_x:=-y_over_x;
          end_if;
          y_over_x:=(y_over_x-1)/(y_over_x+1);
          y:=y_over_x*y_over_x;
          y_over_x:=((((((((0.0028662257*y-0.0161657367)*y+0.0429096138)*y
                            -0.0752896400)*y+0.1065626393)*y-0.1420889944)*y
                            +0.1999355085)*y-0.3333314528)*y+1)*y_over_x;
          r:=kk*(0.785398163397+y_over_x);
        end_if;
      
        //correct for quadrant
        if x<0 then
          r:=r+k*3.14159265358979;
        end_if;
        result:=r;
      
    end;
    function sqrt(x:real):real; language 'Structured Text';
    // AllocGroupList="User Variables"
    var
      n: real;
      lastX: real;
      i: int;
    var_end;

    begin
       /*
         function sqrt(x:real):real;
      
         Babylonian method for calculating square root.
         Loops until max precision or (in some rare cases)
         until max loop iterations is reached.
      
         I. Skokic, November 2012
      
       */
      
       n:=0.5*x;
       lastX:=0.0;
       i:=0;
       while (n!=lastX) and (i<20) do
         lastX:=n;
         n:=0.5*(n+x/n);
         i:=i+1;
       end_while;
       result:=n;
      
    end;
    function frac(x:real):real; language 'Structured Text';
    begin
      /*
        function frac(x:real):real;
      
        Returns fractional part of a number, frac(4.567)=0.567
      
        I. Skokic, November 2012
      
      */
      
      result:=x-int(x);
      
    end;
    function to2pi(angle_rad:real):real; language 'Structured Text';
    begin
      /*
        function to2pi(angle_rad:real):real;
      
        Reduce angle in rad to 0..2*pi interval.
      
        I. Skokic, November 2012
      */
      
        angle_rad:=angle_rad*0.1591549430919;          // /(2*pi)
        angle_rad:=(angle_rad-int(angle_rad))*6.2831853071796; // *2*pi
        if angle_rad<0 then
          angle_rad:=angle_rad+6.2831853071796;
        end_if;
        result:=angle_rad;
      
    end;
    function sun_pos(year,month:int; day,lat,lng:real):void; language 'Structured Text';
    // AllocGroupList="User Variables"
    var constant
      DE2RA = 0.01745329252;
      RA2DE = 57.29577951308232;
    var_end;

    var
      d: real;
      w: real;
      a: real;
      e: real;
      M: real;
      oblecl: real;
      L: real;
      Ee: real;
      r: real;
      v: real;
      lon: real;
      z: real;
      x_eq: real;
      y_eq: real;
      z_eq: real;
      RA: real;
      Decl: real;
      HA: real;
      az: real;
      alt: real;
      sin_lat: real;
      cos_lat: real;
      cos_decl: real;
      x: real;
      y: real;
    var_end;

    begin
       /*
      
          function sun_pos(year,month:int; day,lat,lng:real):void;
      
          Sun position for a given date and position.
      
          Prerequisites:
            math functions: sin, cos, sqrt, atan2, frac, to2pi
            global variables: sun_alt, sun_az: real;
      
          Input:
            year, month - integer, time instant should be in Universal Time (UT) = Local time - Time Zone
            day - real, includes fractional part of the day i.e. hr/24.0+min/1440.0+sec/86400.0
            lat, lng - real, in degrees, S/W negative
      
          Output:
            sun_alt, sun_az - Sun altitude and azimuth in degrees, azimuth is 0 deg North, 90 deg East...
      
          Based on Paul Schluyter's "Computing planetary positions"
          http://www.stjarnhimlen.se/comp/tutorial.html
          Accurate to 0.01 degrees between the years 1900-2099, no refraction.
      
          It takes significant amount of PLC scan time (around 30ms), so the best practice is to call
          this function only when neccessary (e.g. once per second) to avoid scan overrun
      
          I. Skokic, November 2012
      
       */
      
         // calculate orbital position
         d:=real(367.0*year-(7*(year+((month+9)/12)))/4+(275*month)/9+day-730530.0);
         w:=DE2RA*(282.9404+4.70935E-5*d);             //  (longitude of perihelion)
         a:=1.000000;                                  //  (mean distance, a.u.)
         e:=0.016709-1.151E-9*d;                       //  (eccentricity)
         M:=to2pi(DE2RA*(356.0470+0.9856002585*d));    //  (mean anomaly)
         oblecl:=DE2RA*(23.4393-3.563E-7*d);           //  (obliquity of the ecliptic)
         L:=w+M;
         Ee:=M+e*sin(M)*(1+e*cos(M));
         x:=cos(Ee)-e;
         y:=sin(Ee)*sqrt(1-e*e);
         r:=sqrt(x*x+y*y);
         v:=atan2(y,x);
         lon:=to2pi(v+w);
      
         //convert to rectangular equatorial coordinates
         x:=r*cos(lon);
         y:=r*sin(lon);
         z:=0.0;
         x_eq:=x;
         y_eq:=y*cos(oblecl);
         z_eq:=y*sin(oblecl);
      
         RA:=atan2(y_eq,x_eq);
         Decl:=atan2(z_eq,sqrt(x_eq*x_eq+y_eq*y_eq));
      
         lng:=lng*DE2RA;
         lat:=lat*DE2RA;
      
         HA:=L+3.1415926536+lng+frac(day)*6.2831853072-RA;
      
         cos_decl:=cos(Decl);  //optimization
         x:=cos(HA)*cos_Decl;
         y:=sin(HA)*cos_Decl;
         z:=sin(Decl);
      
         //calculate horizontal coordinates
         cos_lat:=cos(lat);    //optimization
         sin_lat:=sin(lat);
         x_eq:=x*sin_lat-z*cos_lat;
         y_eq:=y;
         z_eq:=x*cos_lat+z*sin_lat;
      
         az:=atan2(y_eq,x_eq)+3.1415926536;
         alt:=atan2(z_eq,sqrt(x_eq*x_eq+y_eq*y_eq));
      
         //convert to degrees
         sun_az:=az*RA2DE;
         sun_alt:=alt*RA2DE;
      
    end;
    function correct_date:void; language 'Structured Text';
    // AllocGroupList="User Variables"
    var
      mjd_int: long;
      mjd_frac: real;
      day_frac: real;
      t: real;
      Z: long;
      A: long;
      B: long;
      C: long;
      D: long;
      E: long;
      G: long;
    var_end;

    begin
      /*
        function correct_date:void;
      
        Corrects invalid dates to real dates, e.g. 2012-01-34 25:12:04 into 2012-02-04 01:12:04
      
        Prerequisites:
          Global variables: year, month, day, hour, minute, second: integer;
      
        Useful for doing time simulations where you can just add the time step to month or day
        and call correct_date() to convert it to a meaningful value
      
        I. Skokic, November 2012
      
      */
      
        // convert date to modified julian day (to preserve accuracy, use separate variables for fractional and decimal part)
        day_frac:=hour/24.0+minute/1440.0+second/86400.0;
        mjd_int:=long(real(367.0*year-(7*(year+((month+9)/12)))/4+(275*month)/9+day-678987.0+int(day_frac)));
        mjd_frac:=day_frac-int(day_frac);
        if mjd_frac<0 then
          mjd_int:=mjd_int-1;
          mjd_frac:=mjd_frac+1;
        end_if;
      
        // convert back to calendar date, ref. J. Meeus, Astronomical Algorithms, 2 ed., Willmann-Bell
        Z:=mjd_int+2400001;
        if Z<2299161 then
          A:=Z;
        else
          G:=long((Z-1867216.25)/36524.25);
          A:=Z+1+G-G/4;
        end_if;
        B:=A+1524;
        C:=long((B-122.1)/365.25);
        D:=long(365.25*C);
        E:=long((B-D)/30.6001);
        day:=int(B-D-long(30.6001*E));
        if E<14 then
          month:=int(E-1);
          year:=int(C-4716);
        else
          month:=int(E-13);
          year:=int(C-4715);
        end_if;
      
        // deal with fraction part
        t:=mjd_frac*24;
        hour:=int(t);
        t:=(t-hour)*60;
        minute:=int(t);
        t:=(t-minute)*60;
        second:=int(t);
    end;
  begin
    /*************************************************************************************************************
       SolarTracker
       Tracks the position of the Sun in the local sky for the given date, timezone and geographical coordinates
       I. Skokic, Nov 2012
    *************************************************************************************************************/
    
    if fn(ee_read_req) then
      year:=rtc_year;
      month:=rtc_month;
      day:=rtc_date;
      hour:=rtc_hour;
      minute:=rtc_min;
      second:=rtc_sec;
    end_if;
    
    if fp(simulation) then
      time_dir:=1;
    end_if;
    
    if fp(clock_100ms) then
      if simulation then
        case time_unit of
          0: second:=second+time_dir*time_step;
          1: minute:=minute+time_dir*time_step;
          2: hour:=hour+time_dir*time_step;
        end_case;
      else
        year:=rtc_year;
        month:=rtc_month;
        day:=rtc_date;
        hour:=rtc_hour;
        minute:=rtc_min;
        second:=rtc_sec;
        time_dir:=0;
      end_if;
    
      correct_date();
    
      //limit to valid date
      if year<1900 then
        year:=1900;
      elsif year>2099 then
        year:=2099;
      end_if;
    
      sun_pos(year,month,day+(hour-time_zone)/24.0+minute/1440.0+second/86400.0,latitude,longitude);
    
      r:=300*(1.0-sun_alt/90.0);
      sun_y:=int(100+300-40-r*cos(sun_az*0.01745329252));
      sun_x:=int(100+300-40-r*sin(sun_az*0.01745329252));
    end_if;
    
  end;
begin
  
  analog_clock();
  floor_plan();
  solar_tracker();
  pacman();
  timeplot();
  gsm_demo();
  
end;
#CODE_END

#DESCRIPTION_BEGIN
#DESCRIPTION_END

##PROGRAM_END_1

